/* ColorTrackerV3
   By: Francisco Dias - XicoMBD
   27 October 2010
*/

import processing.serial.*;
import JMyron.*;
import controlP5.*;

Serial TheBox;
JMyron m;
ControlP5 controlP5;
Textfield myTextfield;

int RedValue = 255;
int GreenValue = 25;
int BlueValue = 25;
int RangeValue = 175;
int DensityValue = 1100;

int xmin = 130;
int xmax = 190;
int ymax = 120;

int cx=0; //Bounding box x center
int cy=0; //Bounding box y center

int xd=0; 

String COMPort = "";

int stage = 0;
 
  
void setup(){
  size(320,485);
  m = new JMyron();
  m.start(320,240);
  m.findGlobs(1);
 
 controlP5 = new ControlP5(this);

  controlP5.addTextfield("COMPort",100,450,100,20);

  controlP5.addSlider("RedValue",0,255,RedValue,80,275,100,10);
  controlP5.addSlider("GreenValue",0,255,GreenValue,80,300,100,10);
  controlP5.addSlider("BlueValue",0,255,BlueValue,80,325,100,10);
  controlP5.addSlider("RangeValue",0,255,RangeValue,80,350,100,10);
  controlP5.addSlider("DensityValue",0,10000,DensityValue,80,375,100,10);

  controlP5.addSlider("xmin",0,320,xmin,0,240,320,5);
  controlP5.addSlider("xmax",0,320,xmax,0,245,320,5);
  controlP5.addSlider("ymax",0,240,ymax,315,0,5,240);
}


void draw(){

  background(0); 

// Defines the COM port
  if (stage==0){
  String[] m1 = match(COMPort, "COM");
    if (m1 != null) {
      // This will print to the console.
      stage=2;
     TheBox = new Serial(this,COMPort,4800);
     println(COMPort);
     size(320,450);
    }  
   } 

// Draws the restangle bellow the image  
  fill(RedValue,GreenValue,BlueValue);
   rect(0, 250, 320, 10);

// Defines Desinty, Range and Color
  m.minDensity(DensityValue); //minimum pixels in the glob required to result in a box
  m.trackColor(RedValue,GreenValue,BlueValue,RangeValue);//R, G, B, and range of similarity
  m.update();


//first draw the camera view onto the screen
 int[] img = m.image(); //get the normal image of the camera
  loadPixels();
  for(int i=0;i<320*240;i++){ //loop through all the pixels
    pixels[i] = img[i]; //draw each pixel to the screen
  }
  updatePixels();
 
 // Draws the lines in the image
  stroke(255,0,0);
    line(xmin,0,xmin,240); 
    line(xmax,0,xmax,240); 
    line(0,ymax,320,ymax); 
 
  
  noFill();
  int[][] a;

 

  //draw bounding boxes of globs
  a = m.globBoxes();
  stroke(255,150,0);

  for(int i=0;i<a.length;i++){
    int[] b = a[i];
 
    cx = b[0]+(b[2]/2);
    cy = b[1]+(b[3]/2);

    rect(b[0], b[1], b[2], b[3]);
    stroke(255,255,0);
    line(cx,0,cx,240); 
    line(0,cy,320,cy); 

   xd=1;
}



  //draw center points of globs
  a = m.globCenters();
  stroke(255,255,0);
  for(int i=0;i<a.length;i++){
    int[] p = a[i];
    point(p[0],p[1]);
  }

  //draw edge pixels of globs (this and the next chunks of code are chokers)
  int list[][][] = m.globPixels();
  stroke(110,110,110);
  
  for(int i=0;i<list.length;i++){
    int[][] pixellist = list[i];
    if(pixellist!=null){
      beginShape(POINTS);
      for(int j=0;j<pixellist.length;j++){    
        vertex( pixellist[j][0]  ,  pixellist[j][1] );
       // print( pixellist[j][0]  +" " +  pixellist[j][1] );
      }
      endShape();
     }
  }

  //draw edge points (same as last, but vector based)
  list = m.globEdgePoints(20);
  stroke(0,128,0);
  for(int i=0;i<list.length;i++){
    int[][] contour = list[i];
    if(contour!=null){
      beginShape();
      for(int j=0;j<contour.length;j++){    
        vertex( contour[j][0]  ,  contour[j][1] );
      }
      endShape();
     }
  }
  

/*
  //draw quads - like bounding box, but a 4-pointed polygon.
  a = m.globQuads(50,51);
  stroke(0,0,100);
  for(int i=0;i<a.length;i++){
    int[] b = a[i];
    quad(b[0], b[1],
         b[2], b[3],
         b[4], b[5],
         b[6], b[7]);
  }
*/

// Sends data to the robot if the COM port has been already defined
if (stage==2){
  fill(255);
  text("Commands being sent:",90,415);
  
if (xd==1){  

  if(cx>xmin && cx<xmax){
   if(cy>ymax){
     TheBox.write('w');
     println("w - Go Foward");
     text("w - Go Foward",120,435);
    }else{
     TheBox.write('s');
     println("s - Go Backward");
     text("s - Go Backward",120,435);
    }
   }
 if(cx>xmax){
   TheBox.write('w');
   TheBox.write('a');
   println("a - Turn Right");
   text("a - Turn Right",120,435);
  }
 if(cx<xmin){
   TheBox.write('w');
   TheBox.write('d');
   println("d - Turn Left");
   text("d - Turn Left",120,435);
  }
 }
 
if (xd == 0){
  TheBox.write('g'); 
  println("g - Stop");
  text("g - Stop",120,435);
}

delay(100);
  xd=0; 
}
}


public void stop(){
  m.stop();
  super.stop();
}

/*
void mousePressed(){
if (mouseY<240){
  m.settings();
   }
 }
 */
